﻿@page "/charges"
@attribute [Authorize(Roles = "Contributor")]
@using CarLog.Domain.Entities

<h3>Add Charges</h3>

<SfSpinner @bind-Visible="IsLoading" Label="Loding data..." />

<EditForm Model="@_charge">
    <DataAnnotationsValidator />
    <div class="input-group mb-3">
        <SfDatePicker TValue="DateTime" @bind-Value="_charge.TimeStamp"
                      Format="dd.MM.yyyy"
                      Placeholder="Charge date"
                      FloatLabelType="@FloatLabelType.Auto">
            <DatePickerEvents TValue="DateTime" />
        </SfDatePicker>
    </div>
    <div class="input-group mb-3">
        <SfCheckBox @ref="isPublicCharger"
                    Label="Public Charger" @bind-Checked="_charge.IsPublicCharger" />
    </div>
    <div class="row">
        <div class="col">
            <SfCard>
                <CardHeader Title="Charger information" />
                <CardContent>
                    <div class="input-group mb-3">
                        <SfComboBox TValue="int?" TItem="ChargeProvider" DataSource="@Providers"
                                    AllowFiltering="true" Placeholder="Select the charging provider">
                            <ComboBoxFieldSettings Value="Id" Text="ProviderName" />
                            <ComboBoxEvents TItem="ChargeProvider" TValue="int?" ValueChange="@OnProviderChange" />
                            <ValidationMessage For="@(()=>_charge.StationProviderId)" />
                        </SfComboBox>
                    </div>
                    <div class="input-group mb-3">
                        <SfNumericTextBox TValue="decimal" @bind-Value="_charge.StationPower"
                                          Placeholder="Station power"
                                          FloatLabelType="@FloatLabelType.Auto">
                            <ValidationMessage For="@(()=>_charge.StationPower)" />
                        </SfNumericTextBox>
                    </div>
                    <div class="input-group mb-3">
                        <SfNumericTextBox TValue="decimal" @bind-Value="_charge.ChargedUnits"
                                          Placeholder="Charged Units"
                                          FloatLabelType="@FloatLabelType.Auto">
                            <ValidationMessage For="@(()=>_charge.ChargedUnits)" />
                        </SfNumericTextBox>
                    </div>
                    <div class="input-group mb-3">
                        <SfCheckBox Label="Compute charging units based on the start and end states"
                                    @bind-Checked="_charge.IsComputedCharge" Disabled="true" />
                    </div>
                    <div class="input-group mb-3">
                        <SfNumericTextBox TValue="decimal" @bind-Value="_charge.UnitCost"
                                          Placeholder="Unit cost"
                                          FloatLabelType="@FloatLabelType.Auto">
                            <ValidationMessage For="@(()=>_charge.UnitCost)" />
                        </SfNumericTextBox>
                    </div>
                    <div class="input-group mb-3">
                        <SfNumericTextBox TValue="int" @bind-Value="_charge.ChargedMinutes"
                                          Placeholder="Unit cost"
                                          FloatLabelType="@FloatLabelType.Auto">
                            <ValidationMessage For="@(()=>_charge.ChargedMinutes)" />
                        </SfNumericTextBox>
                    </div>
                </CardContent>
            </SfCard>
        </div>
        <div class="col">
            <SfCard>
                <CardHeader Title="Car information" />
                <CardContent>
                    <div class="input-group mb-3">
                        <SfTextBox FloatLabelType="@FloatLabelType.Always" Placeholder="Selected Car" />
                    </div>
                    <div class="input-group mb-3">
                        <SfNumericTextBox TValue="decimal" @bind-Value="_charge.StartPercent"
                                          Placeholder="Start State of Charge"
                                          FloatLabelType="@FloatLabelType.Auto">
                            <ValidationMessage For="@(()=>_charge.StartPercent)" />
                        </SfNumericTextBox>
                    </div>
                    <div class="input-group mb-3">
                        <SfNumericTextBox TValue="decimal" @bind-Value="_charge.EndPercent"
                                          Placeholder="End State of Charge"
                                          FloatLabelType="@FloatLabelType.Auto">
                            <ValidationMessage For="@(()=>_charge.EndPercent)" />
                        </SfNumericTextBox>
                    </div>
                    @if (ShowHomeIndex)
                    {
                        <div class="input-group mb-3">
                            <SfNumericTextBox TValue="decimal" @bind-Value="_charge.StartIndex"
                                              Placeholder="Start Index"
                                              FloatLabelType="@FloatLabelType.Auto">
                                <ValidationMessage For="@(() => _charge.EndPercent)" />
                            </SfNumericTextBox>
                        </div>
                        <div class="input-group mb-3">
                            <SfNumericTextBox TValue="decimal" @bind-Value="_charge.EndIndex"
                                              Placeholder="End Index"
                                              FloatLabelType="@FloatLabelType.Auto">
                                <ValidationMessage For="@(() => _charge.EndPercent)" />
                            </SfNumericTextBox>
                        </div>
                    }
                </CardContent>
            </SfCard>
        </div>
    </div>
    <br/>
    <div class="input-group mb-3">       
                <SfButton Content="Add log" HtmlAttributes="@addLogAttributes" />
    </div>
</EditForm>